function round(number, decimals)
    local power = 10^decimals
    return math.floor(number * power+0.5) / power
end

function init()
	vehicle = FindVehicle()
	arm = FindJoint("tilt")
	ball = FindJoint("move")

	armAcceleration = 0.25
	armSpeed = 0

	ballMaxSpeed = 8
	ballAcceleration = 0.2
	ballSpeed = 0

	cooldown = 0.1

	lastArmX = 0
	lastBallX = 0
end

function tick(dt)
	if GetPlayerVehicle() == vehicle then
		if lastArmX > cooldown then
			if arm ~= nil then
				if InputPressed("x") then
					if armSpeed < armAcceleration then
						armSpeed = armAcceleration
					else
						armSpeed = 0
					end
					lastArmX = 0
				elseif InputPressed("c") then
					if armSpeed > -armAcceleration then
						armSpeed = -armAcceleration
					else
						armSpeed = 0
					end
					lastArmX = 0
				end
				SetJointMotor(arm, armSpeed)
			end
		else
			lastArmX = lastArmX + dt
		end
		if ball ~= nil then
			if lastBallX > cooldown then
				if InputPressed("lmb") then
					if ballSpeed < ballMaxSpeed then
						ballSpeed = ballSpeed + ballAcceleration
						lastBallX = 0
					end
				elseif InputPressed("rmb") then
					if ballSpeed > -ballMaxSpeed then
						ballSpeed = ballSpeed - ballAcceleration
						lastBallX = 0
					end
				end
			else
				lastBallX = lastBallX + dt
			end
			SetJointMotor(ball, ballSpeed)	
		end
	end
end
	

function draw()
	if vehicle == GetPlayerVehicle() then
		local info = {}
        info[#info+1] = {"Rotation Speed", ""..round(ballSpeed, 2)}
        info[#info+1] = {"C", "Arm Raise"}
		info[#info+1] = {"X", "Arm Lower"}
        info[#info+1] = {"LMB", "Rotate Left"}
		info[#info+1] = {"RMB", "Rotate Right"}
		info[#info+1] = {"Press Again", "Change Speed"}
		UiPush()
			UiAlign("top left")
			local w = 200
			local h = #info*22 + 30
			UiTranslate(20, UiHeight()-h-20)
			UiColor(0,0,0,0.5)
			UiImageBox("common/box-solid-10.png", 300, h, 6, 6)
			UiTranslate(150, 32)
			UiColor(1,1,1)
			for i=1, #info do
				local key = info[i][1]
				local func = info[i][2]
				UiFont("bold.ttf", 22)
				UiAlign("right")
				UiText(key)
				UiTranslate(10, 0)
				UiFont("regular.ttf", 22)
				UiAlign("left")
				UiText(func)
				UiTranslate(-10, 22)
			end
		UiPop()
	end
end